/*
 * file: pv_bs.h
 * This file is part of the libpv library.
 *
 * Copyright 2005 Pengutronix
 *
 * Please send bug reports to bugs@pengutronix.de
 *
 * See COPYING for the status of this software.
 */

#ifndef PV_BS_H
#define PV_BS_H

#include <pv_types.h>

int	pv_bs_init	(struct pv_engine	*engine,
			 enum pv_bs_store_type	store_type,
			 const char		*store_filename,
			 size_t			size);

int	pv_bs_destroy	(struct pv_engine	*engine);


static inline void
	pv_bs_flush_rel	(struct pv_engine	*engine,
			 off_t			off,
			 size_t			len)
{
	if (engine->store.shmid < 0)
		return;

	engine->store.write(&engine->store, off, len);
}


static inline void
	pv_bs_flush_abs	(struct pv_engine	*engine,
			 void			*ptr,
			 size_t			len)
{
	pv_bs_flush_rel(engine, ptr - engine->store.map, len);
}


static inline void
	pv_bs_flush_pv	(struct pv_engine	*engine,
			 struct pv		*pv)
{
	pv_bs_flush_rel(engine, pv->offset, pv->size);
}


static inline void
	pv_bs_flush_all	(struct pv_engine	*engine)
{
	return pv_bs_flush_rel(engine, 0, engine->store.size);
}

#endif	/* !PV_BS_H */
